//-----------------------------------------------------------------------------
//|                                                                           |
//|                                                                           |
//-----------------------------------------------------------------------------
#property copyright ""
#property link      ""

// ----------------- Settings ----------------------------
#property   indicator_separate_window
// ---------------- Settings -------------------------
#property   indicator_buffers 4
// ---------------- Settings --------------------------------
#property   indicator_color1           DodgerBlue
#property   indicator_color2           Red 
#property   indicator_color3           LimeGreen
#property   indicator_color4           Yellow
// ---------------- Settings -----------------------------------
#property   indicator_width1           2
#property   indicator_width2           2
#property   indicator_width3           2
#property   indicator_width4           3
// ---------------- Settings -----------------------------------
#property   indicator_style1           0
#property   indicator_style2           0
#property   indicator_style3           0
#property   indicator_style4           0
//----------------- Settings ==========--------------------
extern      int    BandsPeriod      =  5;      // BollingerBands period
extern      double BandsDeviations  =  1.0;     // BollingerBands sensitivity
            int    BandsShift       =  0;       // BollingerBands shift
//----------------- Settings --------------------------
            double MovingBuffer[];
            double UpperBuffer[];
            double LowerBuffer[];
            double Val_BarsBuffer[];
            
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   IndicatorDigits         (1);
//--------- Settings --------------------------------------
   IndicatorBuffers        (4);
//---------- Settings -------------------------
   SetIndexStyle           (0,   DRAW_LINE);
   SetIndexDrawBegin       (0,   BandsPeriod+BandsShift);

   SetIndexStyle           (1,   DRAW_LINE);
   SetIndexDrawBegin       (1,   BandsPeriod+BandsShift);

   SetIndexStyle           (2,   DRAW_LINE);
   SetIndexDrawBegin       (2,   BandsPeriod+BandsShift);
   
   SetIndexStyle           (3,   DRAW_HISTOGRAM);
   SetIndexDrawBegin       (3,   BandsPeriod+BandsShift);
//---------- Settings -------------------
   SetIndexBuffer          (0,   MovingBuffer);
   SetIndexBuffer          (1,   UpperBuffer);
   SetIndexBuffer          (2,   LowerBuffer);
   SetIndexBuffer          (3,   Val_BarsBuffer);
// ----------- Settings ---------------
   SetIndexEmptyValue      (0,   0.0);   
   SetIndexEmptyValue      (1,   0.0);   
   SetIndexEmptyValue      (2,   0.0);   
   SetIndexEmptyValue      (3,   0.0);
//------------------ Settings ---------------------
   SetIndexLabel           (0,   "Mov");
   SetIndexLabel           (1,   "Up");   
   SetIndexLabel           (2,   "Down");   

   return(0);
}
//+------------------------------------------------------------------+
//| Bollinger Bands                                                  |
//+------------------------------------------------------------------+
int start()
{
   int      i,
            k,
            counted_bars   =  IndicatorCounted();
   double   deviation;
   double   sum,  
            oldval,
            newres;
//----
   if(Bars           <= BandsPeriod) 
      return(0);
//---------------- Settings --------------------------------
   int limit         =  Bars  -  counted_bars;
   if(counted_bars   >  0) 
      limit++;
   for(i =  0;    i  <  limit;   i++)
      Val_BarsBuffer[i] =  (High[i] -  Low[i])  /  Point;
   for(i =  0;    i  <  limit;   i++)
      MovingBuffer[i]   =  iMAOnArray(Val_BarsBuffer,
                              Bars, 
                              BandsPeriod,
                              BandsShift,
                              MODE_SMA,            // MODE_SMA, MODE_EMA, MODE_SMMA, MODE_LWMA
                              i);       
//--------------- Settings ----------------------------
   i                 =  Bars  -  BandsPeriod    +  1;
   if(counted_bars   >  BandsPeriod -  1) 
      i              =  Bars  -  counted_bars   -  1;
   while(i           >= 0)
   {
      sum            =  0.0;
      k              =  i  +  BandsPeriod -  1;
      oldval         =  MovingBuffer[i];
      while(k        >= i)
      {
         newres      =  Val_BarsBuffer[k] -  oldval;
         sum         += newres   *  newres;
         k--;
      }
      deviation      =  BandsDeviations   *  MathSqrt(sum   /  BandsPeriod);
      UpperBuffer[i] =  oldval   +  deviation;
      LowerBuffer[i] =  oldval   -  deviation;
      i--;
   }
//----------------- Settings --------------------------------
     return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
  
   return(0);
}